package models

import "time"

type Pendaftaran_ta_status_enum string

const (
	NOT_ASSIGNED Pendaftaran_ta_status_enum = "NOT_ASSIGNED"
	INTERVIEW    Pendaftaran_ta_status_enum = "INTERVIEW"
	APPROVED     Pendaftaran_ta_status_enum = "APPROVED"
	REJECTED     Pendaftaran_ta_status_enum = "REJECTED"
)

type PendaftaranTA struct {
	ID              string                     `gorm:"type:uuid;primaryKey;default:gen_random_uuid();unique"` // UUID as a string
	IdTopik         string                     `gorm:"type:uuid"`
	IdMahasiswa     string                     `gorm:"type:uuid"`
	IdDosen         string                     `gorm:"type:uuid"`
	Status          Pendaftaran_ta_status_enum `gorm:"type:pendaftaran_ta_status_enum;default:NOT_ASSIGNED"`
	JalurPilihan    string                     `gorm:"default:null"`
	InterviewAt     time.Time                  `gorm:"default:null"`
	DecidedAt       time.Time                  `gorm:"default:null"`
	WaktuPengiriman time.Time                  `gorm:"autoCreateTime"`
	Dosen           Pengguna                   `gorm:"foreignKey:IdDosen;references:ID"`
	Mahasiswa       Pengguna                   `gorm:"foreignKey:IdMahasiswa;references:ID"`
	Topik           Topik                      `gorm:"foreignKey:IdTopik;references:ID"`
}

func (PendaftaranTA) TableName() string {
	return "pendaftaran_ta"
}
